/*
@(#)File:           $RCSfile: describe.h,v $
@(#)Version:        $Revision: 1.13 $
@(#)Last changed:   $Date: 2017/04/12 03:58:08 $
@(#)Purpose:        Header file for use with describe
@(#)Author:         J Leffler
@(#)Copyright:      (C) JLSS 1993-2017
@(#)Product:        SQLCMD Version 91.02 (2018-10-28)
*/

/*TABSTOP=4*/

#ifndef DESCRIBE_H
#define DESCRIBE_H

#ifdef MAIN_PROGRAM
#ifndef lint
/* Prevent over-aggressive optimizers from eliminating ID string */
const char jlss_id_describe_h[] = "@(#)$Id: describe.h,v 1.13 2017/04/12 03:58:08 jleffler Exp $";
#endif /* lint */
#endif /* MAIN_PROGRAM */

#include "esqlc.h"

/*
** sql_describe() allocates space for a given sqlda structure.
** The return value should be freed via sql_release() when the work is complete.
** The del_blob_file argument indicates whether any blobs in files should be deleted.
*/
extern void *sql_describe(Sqlda *desc);
extern void sql_release(Sqlda *desc, void *buffer, int del_blob_file);

#endif /* DESCRIBE_H */
